#include "misc/misc_utils.h"
#include "rasteriser/rasteriser.h"
#include "vector/vec.h"
#include "window/window.h"
#include <SDL2/SDL_events.h>
#include <SDL2/SDL_keycode.h>
#include <stdlib.h>

int main(void) {
  colour_t bg =
      (colour_t){.rgba.r = 27, .rgba.g = 38, .rgba.b = 79, .rgba.a = 255};
  window_t window = {0};

  if (!init_window(&window, 800, 800, "CG From Scratch Rasteriser")) {
    return EXIT_FAILURE;
  }

  bool running = true;
  SDL_Event event = {0};

  // i32 w_min = ((i32)window.half_width) * -1;
  // i32 w_max = (i32)window.half_width;
  // i32 h_min = ((i32)window.half_height) * -1;
  // i32 h_max = (i32)window.half_height;

  line_t lines[] = {
      (line_t){
          (vec2i_t){.x = -300, .y = 0},
          (vec2i_t){.x = 300, .y = 250},
      },
      (line_t){
          (vec2i_t){.x = -200, .y = -100},
          (vec2i_t){.x = 240, .y = 120},
      },
      (line_t){
          (vec2i_t){.x = -50, .y = -200},
          (vec2i_t){.x = 60, .y = 240},
      },
  };

  u32 count = ARR_LEN(lines);

  while (running) {
    while (SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_QUIT:
        running = false;
        break;
      }
    }

    clear_window(&window, bg);

    for (u32 i = 0; i < count; ++i) {
      draw_line(&window, lines[i], (colour_t){.colour = 0xffffffff});
    }

    swap_buffers(&window);
  }

  close_window(&window);

  return EXIT_SUCCESS;
}
