#include "rasteriser/rasteriser.h"
#include "c_cpp_aliases/aliases.h"
#include "vector/vec.h"
#include "window/window.h"

void draw_line(window_t *wnd, line_t line, colour_t colour) {
  if (line.p1.x < line.p0.x) {
    vec_swap(vec2i_t, line.p0, line.p1);
  }

  i32 x0 = line.p0.x;
  i32 y0 = line.p0.y;
  i32 x1 = line.p1.x;
  i32 y1 = line.p1.y;

  f32 a = ((f32)y1 - y0) / ((f32)x1 - x0);
  f32 y = y0;

  for (i32 x = x0; x <= x1; ++x) {
    set_pixel(wnd, x, (i32)y, colour);
    y += a;
  }
}
